VERSION 5.00
Begin VB.Form FMain 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "ImageHlp"
   ClientHeight    =   4890
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4890
   ScaleWidth      =   4680
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.CommandButton cmdVersionInfo 
      Caption         =   "&ImageHlp Version Info"
      Height          =   375
      Left            =   1313
      TabIndex        =   5
      Top             =   4148
      Width           =   2055
   End
   Begin VB.CommandButton cmdEnsureExist 
      Caption         =   "&Ensure dirs exist"
      Height          =   375
      Left            =   1373
      TabIndex        =   3
      Top             =   2828
      Width           =   1935
   End
   Begin VB.TextBox txtPath 
      Height          =   285
      Left            =   383
      TabIndex        =   2
      Text            =   "C:\Programme\MyAppFolder\"
      Top             =   2348
      Width           =   3915
   End
   Begin VB.CommandButton cmdSearch 
      Caption         =   "&Find file"
      Height          =   375
      Left            =   1673
      TabIndex        =   0
      Top             =   1028
      Width           =   1335
   End
   Begin VB.Label Label3 
      Caption         =   "Klicken Sie diesen Button, um Versionsinformationen ber die imagehlp.dll zu erhalten."
      Height          =   495
      Left            =   360
      TabIndex        =   6
      Top             =   3428
      Width           =   3855
   End
   Begin VB.Label Label2 
      Caption         =   "Geben Sie hier einen Orderpfad an, der bei Bedarf erstellt werden soll. Beachten Sie, dass das letzte Zeichen ein ""\"" sein muss."
      Height          =   615
      Left            =   390
      TabIndex        =   4
      Top             =   1628
      Width           =   3855
   End
   Begin VB.Label Label1 
      Caption         =   "Klicken Sie auf den CommandButton, um Laufwerk C: und D: nach notepad.exe zu durchsuchen."
      Height          =   495
      Left            =   413
      TabIndex        =   1
      Top             =   368
      Width           =   3855
   End
End
Attribute VB_Name = "FMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'
' The ImageHlp DLL contains many functions that are really useful for installation programs
' and application developement tools, but there are also some functions which can be
' easily used in VB applications.
'
Option Explicit

' Ensures that a path exists, if is doesn't exist, the folders are created by the function.
Private Declare Function MakeSureDirectoryPathExists Lib "ImageHlp.dll" (ByVal DirPath As String) As Long

' Searches a tree for a file.
Private Declare Function SearchTreeForFile Lib "ImageHlp.dll" (ByVal RootPath As String, ByVal FileName As String, ByVal OutputPath As String) As Long

' Get version information about imagehlp. The function returns a pointer to an API_VERSION struct.
Private Declare Function ImagehlpApiVersion Lib "ImageHlp.dll" () As Long

Private Type API_VERSION
    MajorVersion As Long
    MinorVersion As Long
    Revision As Long
    Reserved As Long
End Type

' We need this API here to access the API_VERSION structure.
Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal Length As Long)

Private Enum CBoolean
    CFalse = 0&
    CTrue = 1&
End Enum

'
' On success the complete path of the file will be returned.
'
Private Function FindFile(ByVal strPath As String, ByVal strFile As String) As String
    Dim strOutput As String * 1024
    If SearchTreeForFile(strPath, strFile, strOutput) Then
        FindFile = Left$(strOutput, InStr(strOutput, vbNullChar) - 1)
    End If
End Function

Private Sub cmdEnsureExist_Click()
    Dim cboolSuccess As CBoolean
    cboolSuccess = MakeSureDirectoryPathExists(txtPath.Text)
    Call MsgBox("Success:  " & IIf(cboolSuccess = CFalse, "False", "True"))
End Sub

Private Sub cmdSearch_Click()
    
    ' Laufwerke C: und D: nach "notepad.exe" durchsuchen und starten, wenn gefunden.
    Dim strPath As String
    Dim vntLaufwerk As Variant
    For Each vntLaufwerk In Array("C:", "D:")
        strPath = FindFile(vntLaufwerk, "notepad.exe")
        If Len(strPath) > 0 Then
            Call Shell(strPath, vbNormalFocus)
            Debug.Print "Datei auf Laufwerk " & vntLaufwerk & " gefunden!"
            Exit For
        Else
            Debug.Print "Datei auf Laufwerk " & vntLaufwerk & " nicht gefunden!"
        End If
    Next vntLaufwerk
End Sub

Private Sub cmdVersionInfo_Click()
    Dim udtVersion As API_VERSION
    Dim lngLenStruct As Long
    Dim lngPtrToStruct As Long
    lngLenStruct = LenB(udtVersion)
    lngPtrToStruct = ImagehlpApiVersion
    Call CopyMemory(udtVersion, ByVal lngPtrToStruct, lngLenStruct)
    Call MsgBox( _
        "ImageHlp Version Information" & vbNewLine & _
        vbNewLine & _
        "MajorVersion:  " & CStr(udtVersion.MajorVersion) & vbNewLine & _
        "MinorVersion:  " & CStr(udtVersion.MinorVersion) & vbNewLine & _
        "Reserved:  " & CStr(udtVersion.Reserved) & vbNewLine & _
        "Revision:  " & CStr(udtVersion.Revision) _
    )
End Sub
